Java基础——异常体系

  • 在Java中,异常对象都是派生于Throwable类的一个实例,Java的异常体系如下图所示:

   所有的异常都是由Throwable继承而来,在下一层立即分解为两个分支,ErrorException

  • Error错误:描述了Java运行时系统的内部错误和资源耗尽错误。一般是指虚拟机相关的问题,如系统崩溃,虚拟机出错误等,这种错误无法恢复或不可能捕获,将导致应用程序中断,通常不处理。因为如果出现这样的内部错误,除了通告用户,并尽力使程序安全地终止之外,再也无能为力了。
  • Exception异常:Java的异常分为两种,checked Exception(编译时异常)和 RuntimeException(运行时异常)。
  1. checked Exception(编译时异常): Java认为checked Exception都是可以在编译阶段被处理的异常,一般是IOException和SQLException。所以它强制程序处理所有的checked Exception,而RuntimeException无须处理,java程序必须显式处理checked Exception,如果程序没有处理,则在编译时会发生错误,无法通过编译。用try{...}catch{...}finally{...}进行处理或throw和throws抛出异常。
  2. RuntimeException(运行时异常):这些异常一般是由程序逻辑错误引起的,一般都是程序员的错,表示程序存在bug,所以,一般不需要进行异常处理,直接让程序停止,由调用者对代码进行修正。常见的有NullPointException,IndexOutOfBoundsException(下标越界异常),ClassCastException,ArithmeticException(算数运算异常,例如除数为0等),ArrayStoreException (向数组中存放与声明类型不兼容对象异常),NegativeArraySizeException(创建一个大小为负数的数组错误异常),NumberFormatException(数字格式异常)等
    • 出现运行时异常后,系统会自动把异常一直往上层抛(不需要程序员在代码中抛出),一直遇到处理代码。如果没有处理块,到最上层,如果是多线程就由Thread.run()抛出,如果是单线程就被main()抛出。抛出之后,如果是线程,这个线程也就退出了。如果是主程序抛出的异常,那么这整个程序也就退出了。运行时异常是Exception的子类,也有一般异常的特点,是可以被Catch块处理的。只不过往往我们不对他处理罢了。也就是说,你如果不对运行时异常进行处理,那么出现运行时异常之后,要么是线程中止,要么是主程序终止。                                                                                             
    • 如果不想终止,则必须扑捉所有的运行时异常,决不让这个处理线程退出。队列里面出现异常数据了,正常的处理应该是把异常数据舍弃,然后记录日志。不应该由于异常数据而影响下面对正常数据的处理。在这个场景这样处理可能是一个比较好的应用,但并不代表在所有的场景你都应该如此。如果在其它场景,遇到了一些错误,如果退出程序比较好,这时你就可以不太理会运行时异常,或者是通过对异常的处理显式的控制程序退出。
  • Java异常处理方法有:抛出异常,捕捉异常。主要依赖于try、catch、finally、throw、throws五个关键字。
  1. try:它里面放置可能引发异常的代码
  2. catch:后面对应异常类型和一个代码块,用于表明该catch块用于处理这种类型的代码块,可以有多个catch块。
  3. finally:主要用于回收在try块里打开的物力资源(如数据库连接、网络连接和磁盘文件),异常机制总是保证finally块总是被执行。只有finally块执行完成之后,才会回来执行try或者catch块中的return或throw语句,如果finally中使用了return或者 throw等终止方法的语句,则就不会跳回执行,直接停止。
  4. throw:用于抛出一个实际的异常,可以单独作为语句使用,抛出一个具体的异常对象。
  5. throws用在方法签名中,用于声明该方法可能抛出的异常
 1 import java.io.IOException;
 2 
 3 public class Test {
 4     
 5     public static void main(String[] args) {
 6         System.out.println("returning result is " + testException());
 7     }
 8     
 9     public static int testException(){
10         int i = 1 ;
11         try{
12             throw new IOException() ;            
13         }catch(Exception e){
14             System.out.println("catch it !");
15             return i;
16         }finally{
17             i = 2 ;
18             System.out.println("finally ok") ;
19             System.out.println("i = " + i) ;
20             //return i ;
21         }
22     }
23 }

当第20行的return语句注释掉时,输出的结果是    catch it !    finally ok    i = 2    returning result is 1 同时也表明如果try 或 catch 中有return语句,则在进入finally之前,Java的中间缓存变量机制已经将try 或 catch 中返回的结果进行了缓存,执行完finally中的语句后,直接将缓存结果return,而当finally中有return语句时,则直接return当前的结果即可。  当第20行的return语句没有注释掉时,输出的结果是    catch it !    finally ok    i = 2    returning result is 2

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

发表于

我来说两句

0 条评论
登录 后参与评论

相关文章

来自专栏java相关

Shell脚本编程

linux中的变量分为环境变量和普通变量,其中环境变量可以理解为全局变量,在所有shell的子程序中都可以引用,普通变量只能在自己的shell程序中使用,程序结...

24320
来自专栏数据结构与算法

3186 队列练习 2

3186 队列练习 2 时间限制: 1 s 空间限制: 128000 KB 题目等级 : 黄金 Gold 题目描述 Description (此题...

27650
来自专栏IT技术精选文摘

阿里架构师带你深入浅出jvm

28220
来自专栏linux运维学习

linux学习第六十四篇:Shell脚本中的逻辑判断,文件目录属性判断, if特殊用法,case判断

Shell脚本中的逻辑判断 格式1:if 条件 ; then 语句; fi 格式2:if 条件; then 语句; else 语句; fi 格式3:if …; ...

33660
来自专栏Java 源码分析

Java 虚拟机运行时数据区

运行时数据区: Java 虚拟机的运行时数据区按照大的可以分为线程独立使用的数据区,和所有线程共享的数据区。 一.线程独立使用数据区 1.程序计数器 程序计数器...

28250
来自专栏Zephery

2017-03-01学习笔记

知识点 1.java中只有值传递,没有引用传递http://guhanjie.iteye.com/blog/1683637 2.final关键字 final修饰...

37580
来自专栏别先生

python的学习和使用

20400
来自专栏java学习

Java每日一练(2017/7/7)

1 (单选题)有以下程序片段,下列哪个选项不能插入到行 1 。()。 1. 2.public class A{ 3.//do sth 4. } A publ...

413110
来自专栏Android开发指南

7:多线程

31080
来自专栏技术小站

编程填空:第i位替换 编程填空:第i位取反 编程填空:左边i位取反

写出函数中缺失的部分,使得函数返回值为一个整数,该整数的第i位和m的第i位相同,其他位和n相同。

25010

扫码关注云+社区

领取腾讯云代金券